

#ifndef __unknwn_inc__
#typedef IID pointer  // for struct NMOBJECTNOTIFY
#typedef IUnknown pointer
#endif

/*
 Note about CDialog2: call SetHandled if your returned value should be returned as valid message result.
   else the message is dispatched in default way by system dialog manager.
*/

/****** wrapped api's ********

 - WriteText(x,y,text)
 - MessageBox(caption,title,flags)
 - SendMessage(message,Param,lParam)
 - GetParent()
 - LoadAccelerator(int or {w}string) is a renamed wrap (LoadAccelerators is the real api)
 - LoadMenu
*/
// + all coded in pure assembly - small and fast code
// + non-virtual methods are linked only if you call them
// + easy extensible window messages
// + [internal] ultra small 'redirector' from window message to method call (using tables)
// + ansi and unicode version


// used common types
#typedef BOOL       int
#typedef COLORREF   unsigned int
#typedef DWORD      unsigned int
#typedef DWORD_PTR  unsigned int
#typedef FARPROC    unsigned int
#typedef HACCEL     unsigned int
#typedef HBITMAP    unsigned int
#typedef HBRUSH     unsigned int
#typedef HCURSOR    unsigned int
#typedef HDC        unsigned int
#typedef HMENU      unsigned int
#typedef HIMAGELIST unsigned int
#typedef HINSTANCE  unsigned int
#typedef HLOCAL     unsigned int
#typedef HRESULT    int
#typedef HWND       unsigned int
#typedef INT_PTR    int
#typedef LCID       unsigned int
#typedef LPARAM     int
#typedef LRESULT    int
#typedef UINT       unsigned int
#typedef UINT_PTR   unsigned int
#typedef ULONG_PTR  unsigned int
#typedef ULONG      unsigned int
#typedef WPARAM     unsigned int

struct SIZE {int cx;int cy;}

// standard or unicode application?
#ifdef UNICODE
//#use "GuiW.lib"
#else
//#use "GuiA.lib"
#endif

// closing a window or dialog by default destroys the window

/*
sub CWindow2
*/
enum CWNDFLG
{
	CWINDOW_DELETEONCLOSE = 0x00000001, // set after GetControl if new CWindow2 class has been created (if called GetControl in dialog from resource. If the control exists you can now call its methods, else the return value is NULL)
	CWINDOW_DIALOG        = 0x00000002, // set if this is a dialog
	CWINDOW_DLGHANDLED    = 0x00000004, // set if DlgProc should return true and return your value in DWL_MSGRESULT
	CWINDOW_DELETEACCELL  = 0x00000008, // reserved for AddAccelerator to free it in WM_DESTROY or Load/SetAccelerator
	CWINDOW_MSGMAPHANDLED = 0x00000010, // set if message has been found in message tables (DefWindowProc is skipped)
	CWINDOW_MSGMAPUSER    = 0x00000020, // flag for ExecMappedMessage - if set, messages are searched in m_msgmap list, else in __MessageTable array of {word uMsg; word flag; word funcOffset}
                                        // The ExecMappedMessage method is called twice from CWindow2::WndProc. First it search for window message in message list created by MapMessage()
                                        // if the message was found - your (static) method is called and the function returns; else it is called again
                                        // and searches for message in internal message table array. If found - the appropriate method On* is called
                                        // else CallWindowProc or DefWindowProc is called.
	CWINDOW_98ME          = 0x00000040, // whenever we are running on win 98/ME (need it for OnUninitPopupMenu)
	CWINDOW_MSGHANDLED    = 0x00000080, // a flag to detect if you overrided a control method (for events)
	CWINDOW_CONTROL       = 0x00000100  // this bit is always set in CControl constructor
}
// flags for MapMessage
enum MSGMAPFLG
{
	CWINDOW_MSGMAP_SIGNED = 8, // 1xxx  : only for CWINDOW_MSGMAP_LOWORD or CWINDOW_MSGMAP_HIWORD; converts a word to signed int
	CWINDOW_MSGMAP_WPARAM = 0, // x0xx
	CWINDOW_MSGMAP_LPARAM = 4, // x1xx
//	     ignored                  xx00
	CWINDOW_MSGMAP_LOWORD = 1, // xx01
	CWINDOW_MSGMAP_HIWORD = 2, // xx10
	CWINDOW_MSGMAP_DWORD  = 3  // xx11
}
//---------------------------------------
class CWindow2
{
private:
	declare  CWindow2();
	declare _CWindow2();
public:
	declare virtual WndProc(UINT uMsg, WPARAM wParam, LPARAM lParam),LRESULT;
	declare virtual DoDefault(),LRESULT;
	declare virtual GetHDC(),HDC;
	declare virtual ReleaseHDC(HDC hdc,OPT BOOL bRedraw=true);/*partial*/
	declare virtual Create(int l,int t,int w,int h,int style,int exstyle,string *title,opt CWindow2 *parent=0,opt int id=0),HWND;
	declare virtual Destroy();
	// void methods
	declare virtual OnCreate(),LRESULT;
	declare virtual OnInitDialog(HWND hFocusControl),BOOL;
	declare virtual OnClose(),LRESULT;
	declare virtual OnDestroy();
	// drawing
	declare virtual OnEraseBkgnd(HDC hdc),BOOL;
	declare virtual OnPaint(),LRESULT;
	declare virtual OnDrawItem(int nID,DRAWITEMSTRUCT *lpdis),BOOL;
	declare virtual OnMeasureItem(int nID,MEASUREITEMSTRUCT *lpmis),LRESULT;
	declare virtual OnControlColor(HDC hdc,HWND hwnd),LRESULT;
	// keyboard
	declare virtual OnChar(int nChar,int nRepCnt,int nFlags),LRESULT;
	declare virtual OnDeadChar(int nChar,int nRepCnt,int nFlags),LRESULT;
	declare virtual OnSysChar(int nChar,int nRepCnt,int nFlags),LRESULT;
	declare virtual OnSysDeadChar(int nChar,int nRepCnt,int nFlags),LRESULT;
	declare virtual OnUniChar(int nChar,int nRepCnt,int nFlags),LRESULT;
	declare virtual OnKeyDown(int nChar,int nRepCnt,DWORD nFlags),LRESULT;
	declare virtual OnKeyUp(int nChar,int nRepCnt,DWORD nFlags),LRESULT;
	declare virtual OnSysKeyDown(int nChar,int nRepCnt,DWORD nFlags),LRESULT;
	declare virtual OnSysKeyUp(),LRESULT;
	declare virtual OnHotKey(int sysID,int hotkey,int keys);
	// menu
	declare virtual OnInitMenu(HMENU hMenu),LRESULT;
	declare virtual OnInitMenuPopup(HMENU hMenu,int pos,BOOL winmenu),LRESULT;
	declare virtual OnUninitPopupMenu(DWORD dwFlags, HMENU hMenu),LRESULT;
	declare virtual OnContextMenu(int x,int y,HWND hwnd),LRESULT;
	declare virtual OnMenuPick(int nID),LRESULT;
	declare virtual OnMenuSelect(int item,int flags,HMENU hMenu),LRESULT;
	declare virtual OnMenuChar(int nChar,int flags,HMENU hMenu),LRESULT;
	declare virtual OnMenuRButtonUp(int nPos, HMENU hMenu),LRESULT;
	declare virtual OnMenuDrag(int nPos, HMENU hMenu),LRESULT;
	declare virtual OnMenuGetObject(MENUGETOBJECTINFO *mgoi),LRESULT;
	declare virtual OnMenuCommand(int nPos, HMENU hMenu),LRESULT;
	declare virtual OnEnterMenuLoop(BOOL bTracked),LRESULT;
	declare virtual OnExitMenuLoop(BOOL bShortcut),LRESULT;
	declare virtual OnSysCommand(int x,int y,DWORD dwCommand),LRESULT;
	// mouse
	declare virtual OnLButtonDown(int x,int y,DWORD flags),LRESULT;
	declare virtual OnLButtonUp(int x,int y,DWORD flags),LRESULT;
	declare virtual OnLButtonDblClk(int x,int y,DWORD flags),LRESULT;
	declare virtual OnMouseMove(int x,int y,DWORD flags),LRESULT;
	declare virtual OnMouseWheel(int x,int y,int distance,int keys),LRESULT;
	declare virtual OnMouseHover(int x,int y,DWORD flags),LRESULT;
	declare virtual OnMouseLeave(),BOOL;
	declare virtual OnRButtonDown(int x,int y,DWORD flags),LRESULT;
	declare virtual OnRButtonUp(int x,int y,DWORD flags),LRESULT;
	declare virtual OnRButtonDblClk(int x,int y,DWORD flags),LRESULT;
	declare virtual OnMButtonDown(int x,int y,DWORD keys),LRESULT;
	declare virtual OnMButtonUp(int x,int y,DWORD keys),LRESULT;
	declare virtual OnMButtonDblClk(int x,int y,DWORD keys),LRESULT;
	declare virtual OnXButtonDown(int x,int y,int button, int keys),LRESULT;
	declare virtual OnXButtonUp(int x,int y,int button, int keys),LRESULT;
	declare virtual OnXButtonDblClk(int x,int y,int button, int keys),LRESULT;
	// moving and sizing
	declare virtual OnSize(int x,int y,DWORD flags),LRESULT;
	declare virtual OnSizing(int nSide,RECT *rc),LRESULT;
	declare virtual OnMove(int x,int y),LRESULT;
	declare virtual OnMoving(RECT *prc),LRESULT;
	declare virtual OnGetMinMaxInfo(MINMAXINFO *mmi),LRESULT;
	declare virtual OnEnterSizeMove(),LRESULT;
	declare virtual OnExitSizeMove(),LRESULT;
	// clipboard
	declare virtual OnCut();
	declare virtual OnCopy();
	declare virtual OnPaste();
	declare virtual OnClear();
	declare virtual OnUndo(),BOOL;
	// controls
	declare virtual OnCommand(WPARAM wParam,LPARAM lParam),LRESULT; /*calls OnMenuPick or OnControl*/
	declare virtual OnControl(int nID, int nNotifyCode, HWND hControl),LRESULT; /*calls CControl::On* */
	declare virtual OnNotify(int nID,int code,NMHDR *pnmhdr),LRESULT;           /*calls CControl::On* */
	// scrollbars
	declare virtual OnHScroll(int nCommand,int nPos,HWND hScroll),LRESULT;
	declare virtual OnVScroll(int nCommand,int nPos,HWND hScroll),LRESULT;
	// timer
	declare virtual OnTimer(int nIDEvent),LRESULT;
	// focus
	declare virtual OnSetFocus(HWND hwndLostFocus),LRESULT;
	declare virtual OnKillFocus(HWND hwndGotFocus),LRESULT;
	// drag and drop
	declare EnableDragDrop(BOOL enable);
	declare virtual OnDropFiles(void *pDrop);
	// session
	declare virtual OnQueryEndSession(DWORD dwLogoffFlags),BOOL;
	declare virtual OnEndSession(DWORD dwLogoffFlags, BOOL bSessionEnded),LRESULT;
	// 
	declare virtual OnEnterIdle(DWORD flags,HWND hwnd),LRESULT; /*MSGF_DIALOGBOX or MSGF_MENU*/

	declare SetSize(int left,int top,int width,int height,opt BOOL redraw=true);
	declare ProcessMessages(opt BOOL forever=FALSE); /*other wait()*/
	declare SetCaption(string *caption);
	declare WriteText(int x,int y,string *text);
	declare CreateControlEx(string *szClass,int l,int t,int w,int h,int style,int exstyle,int id,string* caption,CWindow2* owner),HWND;

	declare Enable(BOOL enabled);
	declare MessageBox(string *msg,opt string *cap=NULL,opt int flag=0x40),int;
	declare SetControlText(int id, string *text);
	declare GetControlText(int id, string *text, int cch);
	declare GetControl(int id),CWindow2 *; /* return existing, or create autodestructive CWindow2*/
	declare SendMessage(UINT msg, WPARAM wParam,LPARAM lParam),int;
	declare AttachControl(HWND hwndControl),HWND; /*Attaches a window to empty class. NULL if failed*/
	declare DetachControl(),BOOL;
	declare SetGuiFont(); /*control: sends WM_SETFONT; window: SelectObject() in private HDC*/
	declare GetParent(),CWindow2 *;
	// accelerator
	declare LoadAccelerator(void *resid),HACCEL;
	declare SetAccelerator(HACCEL hacc);
//	declare AddAccelerator(); /*not implemented*/
	// menu
	declare LoadMenu(void *resid),HMENU; /*sets the window system menu from resource*/
	// common clipboard
	declare Clear();
	declare Copy();
	declare Cut();
	declare Paste();
	// messaging extension
	declare MapMessage(word uMsg,MSGMAPFLG flags,FARPROC method),BOOL;
private:
	declare ExecMappedMessage(),LRESULT;

public:
	HWND    m_hwnd;    // main handle
	FARPROC m_prev;    // previous window proc (valid if a control has been subclasses)
	HDC     m_hBackDC; // for AWS_AUTODRAW
	HBITMAP m_hBackBM; // for AWS_AUTODRAW
	HBRUSH  m_hBackBR; // for AWS_AUTODRAW
	CWNDFLG m_dwFlags; // bDialog, bDestroyAccel, bDeleteThisOnClose ...
	HACCEL  m_hAccel;
//protected: // read only
	void   *m_msgmap;  // heap struct MSGMAP_USER,1 {word uMsg; word arguments; MSGMAP_USER *next; void *function;}
	UINT    m_uMsg;    // current message for ExecMappedMessage or DodDefault
	WPARAM  m_wParam;  // current wParam
	LPARAM  m_lParam;  // current lParam
}



/* you can define up to 4 arguments for method for mapped message
// Every argument can be a word or dword. Signed word can be expanded to signed int (CWINDOW_MSGMAP_SIGNED)
// Only wParam and lParam can be used as argument, but you can split it in various combinations:
// *** combine flags for leftmost argument. If more arguments to receive then rotate flags to right by 4 bits (<<4) and 'OR' the new flag combination. Repeat.
// - a void method like OnCreate: MapMessage(WM_CREATE, 0, &CMyClass@MyOnCreate);
//     declare {virtual} MyOnCreate();
// - a method with wParam: MapMessage(WM_SETFONT, CWINDOW_MSGMAP_WPARAM|CWINDOW_MSGMAP_DWORD, &CWnd@OnSetFont);
//     declare {virtual} OnSetFont(HFONT hFont);
// - a method with lParam: MapMessage(WM_MOVING, CWINDOW_MSGMAP_LPARAM|CWINDOW_MSGMAP_DWORD, &CWnd@OnMoving);
//     declare {virtual} OnMoving(RECT *pos);
// - a method with wParam,lParam: MapMessage(WM_DELETEITEM, ((CWINDOW_MSGMAP_WPARAM|CWINDOW_MSGMAP_DWORD)<<4) | (CWINDOW_MSGMAP_LPARAM|CWINDOW_MSGMAP_DWORD), &CWnd@OnDeleteItem);
//     declare {virtual} OnDeleteItem(int ctlId, DELETEITEMSTRUCT *pdis);
//     see "<<4" ? every flag has size of 4 bits and you can pass up to 4 arguments to your method (flags are stored in a word)
//     ( flag1<<12, flag2<<8, flag3<<4, flag4 )
//     ( flag1<<8, flag2<<4, flag3) is equal to ( flag1<<12, flag2<<8, flag3<<4 )
// - OnMouseMove(int x,int y,DWORD dwFlags) is more complicated:
//   x = LOWORD(lParam)  flag1 = CWINDOW_MSGMAP_LOWORD | CWINDOW_MSGMAP_LPARAM { | CWINDOW_MSGMAP_SIGNED }
//   y = HIWORD(lParam)  flag2 = CWINDOW_MSGMAP_HIWORD | CWINDOW_MSGMAP_LPARAM { | CWINDOW_MSGMAP_SIGNED }
//   dwFlags = wParam    flag3 = CWINDOW_MSGMAP_DWORD  | CWINDOW_MSGMAP_WPARAM
//   MapMessage(WM_MOUSEMOVE, (flag1<<8) | (flag2<<4) | (flag3<<0), &CWnd@OnMouseMove);
///////////////////////
// ***  you cannot pass mapped messages back to WndProc (deadloop)
// ***  if you cannot handle mapped message - pass it to DefWindowProc(m_hwnd, uMsg, wParam, lParam);
// *** currently mapped messages are removed with WM_DESTROY; inside constructor and Create() - m_msgmap is set to null
*/


/*
sub CDialog2
*/
//---------------------------------------
class CDialog2 : CWindow2
{
	declare CDialog2();
	declare virtual Create(int l,int t,int w,int h,int style,int exstyle,string *title,opt CWindow2 *parent=NULL,opt int id=0),HWND;
	declare virtual Destroy();
	declare virtual OnClose(),BOOL;

	declare CreateDialog(string *template,opt CWindow2* parent=NULL),HWND;
	declare CreateModalDialog(string *template,opt CWindow2* parent=NULL),int;
	declare SetHandled(); /* call this from inside your method before returning valid value*/
	declare CloseDialog(opt int code);
}

/*
sub CControl2
*/
//---------------------------------------
class CControl2 : CWindow2
{
	declare CControl2();
	// methods to redirect messages from parent window to control
	// called only if CWINDOW_CONTROL flag is set in m_flags.
	// if the parent window has received WM_NOTIFY and the control window NMHDR->hwndFrom has an associated class
	// then parent calls this method
	declare virtual ProcessNotify(NMHDR *pnmhdr),LRESULT;    /* calls methods from m_ntpn table for WM_NOTIFY*/
	declare virtual ProcessCommand(int nNotifyCode),LRESULT; /* calls methods from m_ctpn table for WM_COMMAND*/
	// common events (WM_NOTIFY)
	declare virtual OnNmOutOfMemory(NMHDR *pnmhdr),LRESULT;
	declare virtual OnNmClick(NMHDR *pnmhdr),LRESULT;
	declare virtual OnNmDblClk(NMHDR *pnmhdr),LRESULT;
	declare virtual OnNmReturn(NMHDR *pnmhdr),LRESULT;
	declare virtual OnNmRClick(NMHDR *pnmhdr),LRESULT;
	declare virtual OnNmRDblClk(NMHDR *pnmhdr),LRESULT;
	declare virtual OnNmSetFocus(NMHDR *pnmhdr),LRESULT;
	declare virtual OnNmKillFocus(NMHDR *pnmhdr),LRESULT;
	declare virtual OnNmCustomDraw(NMHDR *pnmhdr),LRESULT;
	declare virtual OnNmHover(NMHDR *pnmhdr),LRESULT;
	declare virtual OnNmNChitTest(NMHDR *pnmhdr),LRESULT;
	declare virtual OnNmKeyDown(NMHDR *pnmhdr),LRESULT;
	declare virtual OnNmReleasedCapure(NMHDR *pnmhdr),LRESULT;
	declare virtual OnNmSetCursor(NMHDR *pnmhdr),LRESULT;
	declare virtual OnNmChar(NMHDR *pnmhdr),LRESULT;
	declare virtual OnNmTooltipsCreated(NMHDR *pnmhdr),LRESULT;
	declare virtual OnNmRDown(NMHDR *pnmhdr),LRESULT;
	declare virtual OnNmThemeChanged(NMHDR *pnmhdr),LRESULT;

	void *m_ntpn; // pointer to NULL terminated array {int nNotifyCode, int vtbl_offset} for WM_NOTIFY
	void *m_ctpn; // pointer to NULL terminated array {int nNotifyCode, int vtbl_offset} for WM_COMMAND
	COLORREF m_fg;
	COLORREF m_bg;
}
struct NMCUSTOMDRAW {NMHDR hdr;DWORD dwDrawStage;HDC hdc;RECT rc;DWORD_PTR dwItemSpec;UINT uItemState;LPARAM lItemlParam;} 



/*
sub CButton2
*/
//---------------------------------------
class CButton2 : CControl2
{
	declare CButton2();
	declare virtual Create(int l,int t,int w,int h,int style,int exstyle,string *title,CWindow2 *parent,int id),HWND;
	// button events
	declare virtual OnHotItemChange(NMBCHOTITEM *pnmci);
	declare virtual OnClick();
	declare virtual OnBtPaint();
	declare virtual OnPush();
	declare virtual OnUnpush();
	declare virtual OnDisable();
	declare virtual OnBtSetFocus();
	declare virtual OnBtKillFocus();
	declare virtual OnDoubleClick();

	declare GetIdealSize(SIZE *lpSize),BOOL;
	declare SetImageList(BUTTON_IMAGELIST *lpil),BOOL;
	declare GetImageList(BUTTON_IMAGELIST *lpil),BOOL;
	declare SetTextMargin(RECT *prc),BOOL;
	declare GetTextMargin(RECT *prc),BOOL;
	declare Click();
	declare SetCheck(int state);
	declare GetCheck(),int;
	declare SetImage(int type, HANDLE hImage),HANDLE;
	declare GetImage(int type),HANDLE;
	declare SetState(BOOL hilight);
	declare GetState(),int;
	declare SetStyle(DWORD dwStyle, BOOL redraw);
}
struct NMBCHOTITEM {NMHDR hdr;DWORD dwFlags;}
struct BUTTON_IMAGELIST {HIMAGELIST himl;RECT margin;UINT uAlign;}


/*
sub CListView2
*/
#typedef PFNLVGROUPCOMPARE int // sub comparegroup(int group1,int group2,void *data),int {return error;}
#typedef PFNLVCOMPARE int
//---------------------------------------
class CListView2 : CControl2
{
	declare CListView2();
	declare virtual Create(int l,int t,int w,int h,int style,int exstyle,string *title,CWindow2 *parent,int id),HWND;
	// common events overrides
	declare virtual OnNmClick(NMITEMACTIVATE *pnmhdr),LRESULT;
	declare virtual OnNmDblClk(NMITEMACTIVATE *pnmhdr),LRESULT;
	declare virtual OnNmReturn(NMHDR *pnmhdr),LRESULT;
	declare virtual OnNmRClick(NMITEMACTIVATE *pnmhdr),LRESULT;
	declare virtual OnNmRDblClk(NMITEMACTIVATE *pnmhdr),LRESULT;
	declare virtual OnNmSetFocus(NMHDR *pnmhdr),LRESULT;
	declare virtual OnNmKillFocus(NMHDR *pnmhdr),LRESULT;
	declare virtual OnNmCustomDraw(NMLVCUSTOMDRAW *pnmhdr),LRESULT;
	declare virtual OnNmHover(NMHDR *pnmhdr),LRESULT;
	declare virtual OnNmReleasedCapure(NMHDR *pnmhdr),LRESULT;
	// listview events
	declare virtual OnItemChanging(NMLISTVIEW *pnmlv),LRESULT;
	declare virtual OnItemChanged(NMLISTVIEW *pnmlv),LRESULT;
	declare virtual OnInsertItem(NMLISTVIEW *pnmlv),LRESULT;
	declare virtual OnDeleteItem(NMLISTVIEW *pnmlv),LRESULT;
	declare virtual OnDeleteAllItems(NMLISTVIEW *pnmlv),LRESULT;
	declare virtual OnBeginLabelEdit(NMLVDISPINFO *pnmdi),LRESULT;
	declare virtual OnEndLabelEdit(NMLVDISPINFO *pnmdi),LRESULT;
	declare virtual OnColumnClick(NMLISTVIEW *pnmlv),LRESULT;
	declare virtual OnBeginDrag(NMLISTVIEW *pnmlv),LRESULT;
	declare virtual OnBeginRDrag(NMLISTVIEW *pnmlv),LRESULT;
	declare virtual OnItemActivate(NMITEMACTIVATE *pnmia),LRESULT; /*IE >= 4.71*/
	declare virtual OnHotTrack(NMLISTVIEW *pnmlv),LRESULT;
	declare virtual OnGetDispInfo(NMLVDISPINFO *pnmdi),LRESULT;
	declare virtual OnSetDispInfo(NMLVDISPINFO *pnmdi),LRESULT;
	declare virtual OnLvKeyDown(NMLVKEYDOWN *pnmkd),LRESULT;
	declare virtual OnMarqueeBegin(NMLISTVIEW *pnmlv),LRESULT;
	declare virtual OnGetInfoTip(NMLVGETINFOTIP *pnmit),LRESULT;
	declare virtual OnBeginScroll(NMLVSCROLL *pnms),LRESULT;
	declare virtual OnEndScroll(NMLVSCROLL *pnms),LRESULT;
	declare virtual OnOdCacheHint(NMLVCACHEHINT *pnmch),LRESULT;
	declare virtual OnOdStateChanged(NMLVODSTATECHANGE *pnmst),LRESULT;
	declare virtual OnOdFindItem(NMLVFINDITEM *pnmfi),LRESULT;
	// columns
	declare GetHeader(),HWND;
	declare DeleteColumn(int index),BOOL;
	declare GetColumn(int index,LVCOLUMN *lpcol),BOOL;
	declare SetColumn(int index,LVCOLUMN *info),BOOL;
	declare GetColumnFormat(int index),DWORD;
	declare SetColumnFormat(int index,DWORD format),BOOL;
	declare GetColumnWidth(int index),DWORD;
	declare SetColumnWidth(int index,DWORD width),BOOL;
	declare GetColumnText(int index, string *lpsz,int cch),BOOL;
	declare SetColumnText(int index,string *text),BOOL;
	declare GetColumnImage(int index),int;
	declare SetColumnImage(int index,int nImage),BOOL;
	declare GetColumnSubItem(int index),int;
	declare SetColumnSubItem(int index,int subitem),BOOL;
	declare GetColumnOrder(int index),int;
	declare SetColumnOrder(int index,int order),BOOL;
	declare GetSelectedColumn(),UINT;
	declare SetSelectedColumn(int index);
	declare InsertColumn(int col,opt string *title=0,opt int width=-1,opt int fmt=-1,opt int image=-1,opt int subitem=-1),int;
	declare InsertColumnEx(int index,LVCOLUMN *pcol),int;
	declare GetColumnOrderArray(int count,DWORD *array),BOOL;
	// items
	declare GetItem(LVITEM *item),BOOL;
	declare SetItem(LVITEM *item),BOOL;
	declare GetItemText(int nItem,int subitem,string *lpstr,int cch),BOOL;
	declare SetItemText(int nItem,int subitem,string *text),BOOL;
	declare SetItemData(int nItem,void *data),BOOL;
	declare GetItemData(int nItem),void *;
	declare GetItemImage(int nItem,int subitem),int;
	declare SetItemImage(int nItem,int subitem,int nImage),int;
	declare GetItemIndent(int nItem,int subitem),int;
	declare SetItemIndent(int nItem,int subitem,int indent),int;
	declare GetItemGroupId(int nItem,int subitem),int;
	declare SetItemGroupId(int nItem,int subitem,int id),int;
	declare GetItemColumns(int nItem,int subitem,int count,DWORD *array),int;
	declare SetItemColumns(int nItem,int subitem,int count,DWORD *array),int;
	declare GetItemState(int nItem,int subitem,DWORD mask),DWORD;
	declare SetItemState(int nItem,int subitem,DWORD mask,DWORD state),int;
	declare SetItemCount(int count,opt int flags=0),BOOL;
	declare DeleteItem(int index),BOOL;
	declare DeleteAllItems(),BOOL;
	declare FindItem(int index,UINT flags,string *text,void *data,POINT pt byval,UINT vkDirection),int;
	declare FindItemEx(int index,LVFINDINFO *info),int;
	declare EnsureVisible(int index,BOOL partialOK),BOOL;
	declare GetHotItem(),int;
	declare SetHotItem(int index),int;
	declare GetSubitemRect(int item,int subitem,int flag,RECT *rect),BOOL;
	declare GetSelectedCount(),int;
	declare GetSelectionMark(),int;
	declare SetSelectionMark(int index),int;
	declare GetEditControl(),HWND;
	declare InsertItem(int nItem,opt string *lpszItem=0,opt void data,opt int indent=-1,opt int nImage=-1),int;
	declare InsertItemEx(LVITEM *info),int;
	declare EditLabel(int index),HWND; /*-1:cancel*/
	declare CancelEditLabel();
	declare RedrawItems(int first,int last);
	declare GetStringWidth(string *lpsz),DWORD;
	declare GetTopIndex(),int;
	declare SetItemPosition(int item,word x,word y),BOOL;
	declare SetItemPosition32(int item,int x,int y),BOOL;
	declare GetItemPosition(int item,POINT *pt),BOOL;
	declare SortItems(PFNLVCOMPARE func,void *data),BOOL;
	declare SortItemsEx(PFNLVCOMPARE func,void *data),BOOL;
	// insertion mark
	declare SetInsertMark(int item,BOOL after),BOOL;
	declare SetInsertMarkEx(LVINSERTMARK *info),BOOL;
	declare GetInsertMark(LVINSERTMARK *info),BOOL;
	declare InsertMarkHitTest(POINT *pt,LVINSERTMARK *info),BOOL;
	// styles
	declare SetExtendedStyle(DWORD dwExStyle),DWORD;
	declare GetExtendedStyle(),DWORD;
	// groups
	declare EnableGroupView(BOOL enable),int;
	declare InsertGroup(int index,LVGROUP *group),int;
	declare InsertGroupSorted(LVINSERTGROUPSORTED *info);
	declare GetGroupInfo(int id, LVGROUP *info),int;
	declare SetGroupInfo(int id,LVGROUP *info),int;
	declare GetGroupMetrics(LVGROUPMETRICS *info);
	declare SetGroupMetrics(LVGROUPMETRICS *metrics);
	declare HasGroup(),BOOL;
	declare RemoveGroup(int id),int;
	declare RemoveAllGroups();
	declare MoveGroup(int id,int index);
	declare MoveItemToGroup(int item,int group);
	declare IsGroupViewEnabled(),BOOL;
	declare SortGroups(PFNLVGROUPCOMPARE func,void *data),BOOL;
	// colors
	declare SetTextBkColor(COLORREF color),COLORREF;
	declare GetTextBkColor(),COLORREF;
	declare SetTextColor(COLORREF color),COLORREF;
	declare GetTextColor(),COLORREF;
	declare SetBkColor(COLORREF color),BOOL;
	declare GetBkColor(),COLORREF;
	declare SetBkImage(DWORD flags,string *path,int xOffsetPercent,int yOffsetPercent),BOOL;
	declare SetBkImageEx(LVBKIMAGE *info),BOOL;
	declare GetBkImage(LVBKIMAGE *img),BOOL;
	declare SetImageList(int type,HIMAGELIST hIml),HIMAGELIST;
	declare GetImageList(int type),HIMAGELIST;
	declare GetOutlineColor(),COLORREF;
	declare SetInsertMarkColor(COLORREF color),COLORREF;
	declare GetInsertMarkColor(),COLORREF;
	declare SetOutlineColor(COLORREF color),COLORREF;
	// tiles
	declare SetTileInfo(LVTILEINFO *info),BOOL;
	declare GetTileInfo(LVTILEINFO *info);
//	declare GetTileWidth  SDK: Not currently supported
	declare SetTileViewInfo(LVTILEVIEWINFO *info),BOOL;
	declare GetTileViewInfo(LVTILEVIEWINFO *info);

	declare GetCallbackMask(),DWORD;
	declare SetCallbackMask(DWORD mask),BOOL;
	declare GetHotCursor(),HCURSOR;
	declare SetHotCursor(HCURSOR hCursor),HCURSOR;
	declare SetHoverTime(DWORD time),DWORD;
	declare GetHoverTime(),DWORD;
	declare SetToltips(HWND hwndTip),HWND;
	declare GetTooltips(),HWND;
	declare ApproximateViewRect(int items,word cx,word cy),DWORD;
	declare Arrange(int align),BOOL;
	declare GetCountPerPage(),int;
	declare GetOrigin(POINT *pt),BOOL;
	declare SetUnicodeFormat(BOOL unicode),BOOL;
	declare GetUnicodeFormat(),BOOL;
	declare SetView(DWORD view),int;
	declare GetView(),DWORD;
	declare GetViewRect(RECT *rc),BOOL;
	declare SetWorkAreas(int count,RECT *array);
	declare GetWorkAreas(int count,RECT *array);
	declare HitTest(LVHITTESTINFO *info),int;
	declare SubitemHitTest(LVHITTESTINFO *info),int;
	declare MapIdToIndex(int id),UINT;
	declare MapIndexToId(UINT index),int;

	declare Scroll(int x,int y),BOOL;
	declare SetIconSpacing(int cx,int cy),DWORD;
	declare SetInfoTip(int item,int subitem,wstring *wstr),BOOL;
	declare Update(int index),BOOL;
}
struct NMLVODSTATECHANGE {NMHDR hdr;int iFrom;int iTo;UINT uNewState;UINT uOldState;}
struct NMITEMACTIVATE {NMHDR hdr;int iItem;int iSubItem;UINT uNewState;UINT uOldState;UINT uChanged;POINT ptAction;LPARAM lParam;UINT uKeyFlags;}
struct NMLVGETINFOTIP {NMHDR hdr;DWORD dwFlags;string *pszText;int cchTextMax;int iItem;int iSubItem;LPARAM lParam;} 
struct NMLVCUSTOMDRAW {NMCUSTOMDRAW nmcd;COLORREF clrText;COLORREF clrTextBk;int iSubItem;DWORD dwItemType;COLORREF clrFace;int iIconEffect;int iIconPhase;int iPartId;int iStateId;RECT rcText;UINT uAlign;}
struct NMLVCACHEHINT {NMHDR hdr;int iFrom;int iTo;}
struct LVINSERTMARK {UINT cbSize;DWORD dwFlags;int iItem;DWORD dwReserved;}
struct LVITEM {UINT mask;int iItem;int iSubItem;UINT state;UINT stateMask;string *pszText;int cchTextMax;int iImage;LPARAM lParam;int iIndent;int iGroupId;UINT cColumns;UINT *puColumns;} 
struct NMLVDISPINFO {NMHDR hdr;LVITEM item;}
struct LVFINDINFO {UINT flags;string *psz;LPARAM lParam;POINT pt;UINT vkDirection;} 
struct NMLVFINDITEM {NMHDR hdr;int iStart;LVFINDINFO lvfi;}
struct NMLVKEYDOWN,1{NMHDR hdr;WORD wVKey;UINT flags;}
struct NMLISTVIEW {NMHDR hdr;int iItem;int iSubItem;UINT uNewState;UINT uOldState;UINT uChanged;POINT ptAction;LPARAM lParam;} 
struct NMLVSCROLL {NMHDR hdr;int dx;int dy;}
struct LVBKIMAGE {ULONG ulFlags;HBITMAP hbm;string *pszImage;UINT cchImageMax;int xOffsetPercent;int yOffsetPercent;}
struct LVTILEINFO {UINT cbSize;int iItem;UINT cColumns;UINT *puColumns;}
struct LVTILEVIEWINFO {UINT cbSize;DWORD dwMask;DWORD dwFlags;SIZE sizeTile;int cLines;RECT rcLabelMargin;}
struct LVCOLUMN {UINT mask;int fmt;int cx;string *pszText;int cchTextMax;int iSubItem;int iImage;int iOrder;} 
struct LVHITTESTINFO {POINT pt;UINT flags;int iItem;int iSubItem;}
struct LVGROUP {UINT cbSize;UINT mask;wstring *pszHeader;int cchHeader;wstring *pszFooter;int cchFooter;int iGroupId;UINT stateMask;UINT state;UINT uAlign;}
struct LVINSERTGROUPSORTED {PFNLVGROUPCOMPARE pfnGroupCompare;void *pvData;LVGROUP lvGroup;}

/*
sub CComboBox2
*/
//---------------------------------------
class CComboBox2 : CControl2
{
	declare CComboBox2();
	declare virtual Create(int l,int t,int w,int h,int style,int exstyle,string *title,CWindow2 *parent,int id),HWND;
	// common events overrides - none
	// combobox events
	// unhandled: WM_COMPAREITEM,WM_DRAWITEM,WM_MEASUREITEM
	declare virtual OnErrSpace();
	declare virtual OnSelChange();
	declare virtual OnDblClk();
	declare virtual OnCbSetFocus();
	declare virtual OnCbKillFocus();
	declare virtual OnEditChange();
	declare virtual OnEditUpdate();
	declare virtual OnDropDown();
	declare virtual OnCoseUp();
	declare virtual OnSelEndOk();
	declare virtual OnSelEndCancel();

	declare AddString(string *lpsz),int;
	declare DeleteString(int index),int;
	declare Dir(DWORD dwFlags, string *path),int;
	declare FindString(int startIndex, string *szFind),int;
	declare FindStringExact(int startIndex, string *szFind),int;
	declare GetInfo(COMBOBOXINFO *lpinfo),BOOL;
	declare GetCount(),int;
	declare GetCurSel(),int;
	declare GetDroppedControlRect(RECT *prc),BOOL;
	declare GetDroppedState(),BOOL;
	declare GetDroppedWidth(),int;
	declare GetEditSel(opt DWORD *lpdwSelStart=0,opt DWORD *lpdwSelEnd=0),int;
	declare GetExtendedUi(),BOOL;
	declare GetHorizontalExtent(),int;
	declare GetItemData(int index),void *;
	declare GetItemHeight(int component/*-1:selection;0:item;or item index if CBS_OWNERDRAWVARIABLE*/),int;
	declare GetItemText(int item,string *lptext,int cch),int;
	declare GetItemTextLenght(int item),int;
	declare GetLocale(),LCID;
	declare GetMinVisible(),int;
	declare GetTopIndex(),int;
	declare InsertString(int index,string *lpsz),int;
	declare LimitText(int maxChars);
	declare ResetContent();
	declare SelectString(int index,string *szFind),int;
	declare SetCurSel(int index),int;
	declare SetDroppedWidth(int width),int;
	declare SetEditSel(int start,int end),int;
	declare SetExtendedUi(BOOL extended),int;
	declare SetHorizontalExtent(int width),int;
	declare SetItemData(int index,void *data),int;
	declare SetItemHeight(int component,int height),int;
	declare SetLocale(LCID locale),LCID;
	declare SetMinVisible(int items),BOOL;
	declare SetTopIndex(int index),int;
	declare ShowDropDown(BOOL show),BOOL;
}
struct COMBOBOXINFO {DWORD cbSize;RECT rcItem;RECT rcButton;DWORD stateButton;HWND hwndCombo;HWND hwndItem;HWND hwndList;}
struct COMPAREITEMSTRUCT {UINT CtlType;UINT CtlID;HWND hwndItem;UINT itemID1;ULONG_PTR itemData1;UINT itemID2;ULONG_PTR itemData2;DWORD dwLocaleId;}

/*
sub CEdit2
*/
//---------------------------------------
class CEdit2 : CControl2
{
	declare CEdit2();
	declare virtual Create(int l,int t,int w,int h,int style,int exstyle,string *title,CWindow2 *parent,int id),HWND;
	// edit events
	// unhandled: WM_CTLCOLOREDIT
	declare virtual OnEdSetFocus();
	declare virtual OnEdKillFocus();
	declare virtual OnChange();
	declare virtual OnUpdate();
	declare virtual OnErrSpace();
	declare virtual OnMaxText();
	declare virtual OnEdHScroll();
	declare virtual OnEdVScroll();
	declare virtual OnAlignLtr();
	declare virtual OnAlignRtl();
	// properties
	declare SetCueBanner(wstring *banner),BOOL;
	declare GetCueBanner(wstring *wsz),BOOL;
	declare SetHandle(HLOCAL hLocal);
	declare GetHandle(),HLOCAL;
	declare SetModified(BOOL modified);
	declare GetModified(),BOOL;
	declare SetMargins(int type,int left,int right);
	declare GetMargins(),DWORD;
	declare GetLeftMargin(),DWORD;
	declare GetRightMargin(),DWORD;
	declare SetPasswordChar(int char);
	declare GetPasswordChar(),int; /*byte or word*/
	declare SetLimitText(DWORD limit);
	declare LimitText(int limit);
	declare GetLimitText(),int;
	declare SetImeStatus(int type,int data),int;
	declare GetImeStatus(int type),int;
	declare SetWorkBreakProc(FARPROC fn);
	declare GetWordBreakProc(),FARPROC;
	declare SetSel(int first,int last);
	declare GetSel(int *ppFirst,int *ppLast);
	declare SetRect(int left,int top,int right,int bottom);
	declare SetRectEx(RECT *rc);
	declare SetRectNp(int left,int top,int right,int bottom);
	declare SetRectNpEx(RECT *rc);
	declare GetRect(RECT *rc);
	// clipboard
	declare CanUndo(),BOOL;
	declare Undo(),BOOL;
	declare EmptyUndoBuffer();
	// scrolling
	declare Scroll(int type),BOOL;
	declare ScrollCaret();
	declare LineScroll(int h,int v),BOOL;
	// tabstops
	declare SetTabstops(int count, int *array),BOOL;
	// methods
	declare CharFomPos(word x,word y),int;
	declare FormatLines(BOOL addSoftLineBreakCharacters);
	declare GetFirstVisibleLine(),int;
	declare GetLine(int index,string *lpsz,int cch),int;
	declare GetLineCount(),int;
	declare GetThumb(),int;
	declare HideBalloonTip(),BOOL;
	declare LineFromChar(opt int charindex=-1),int;
	declare LineIndex(opt int line=-1),int;
	declare LineLength(int line),int;
	declare PosFromChar(int char),DWORD;
	declare PosXFromChar(int char),word;
	declare PosYFromChar(int char),word;
	declare ReplaceSel(string *sz,opt BOOL canUndo=true);
	declare SetReadOnly(BOOL ro),BOOL;
	declare ShowBalloonTip(wstring *title,wstring *text,int icon),BOOL;
	declare ShowBalloonTipEx(EDITBALLOONTIP *info),BOOL;

}

/*
sub CListbox2
*/
//---------------------------------------
class CListbox2 : CControl2
{
	declare CListbox2();
	declare virtual Create(int l,int t,int w,int h,int style,int exstyle,string *title,CWindow2 *parent,int id),HWND;
	// unhandled: WM_CHARTOITEM,WM_CTLCOLORLISTBOX,WM_DELETEITEM,WM_VKEYTOITEM
	declare virtual OnDblClk();
	declare virtual OnErrSpace();
	declare virtual OnLbKillFocus();
	declare virtual OnSelCancel();
	declare virtual OnSelChange();
	declare virtual OnLbSetFocus();

	declare SetCount(int count),int;
	declare GetCount(),int;
	declare SetCurSel(int index),int;
	declare GetCurSel(),int;
	declare SetHorizontalExtent(int pixels),int;
	declare GetHorizontalExtent(),int;
	declare SetItemData(int index,void *data),int;
	declare GetItemData(int index),void *;
	declare SetTopIndex(int index),int;
	declare GetTopIndex(),int;
	declare SetItemHeight(int index,int height),int;
	declare GetItemHeight(int index),int;
	declare SetLocale(LCID locale),LCID;
	declare GetLocale(),LCID;
	declare SetSel(BOOL hilight,int index),int;
	declare GetSel(int index),int;
	declare SetCaretIndex(int index,BOOL scroll),int;
	declare GetCaretIndex(),int;
	declare SetAnchorIndex(int index),int;
	declare GetAnchorIndex(),int;
	// selection
	declare SelectString(int index,string *prefix),int;
	declare SelItemRange(BOOL sel,int first,int last),int;
	declare SelItemRangeEx(int first,int last),int;
	declare GetSelCount(),int;
	declare GetSelItems(int count,int *array),int;

	declare AddFile(string *file),int;
	declare AddString(string *text),int;
	declare DeleteString(int index),int;
	declare Dir(int flags,string *dir),int;
	declare FindString(int index,string *szFind),int;
	declare FindStringExact(int index,string *szFind),int;
	declare GetItemRect(int index,RECT *rc),int;
	declare GetListboxInfo(),int;
	declare GetItemText(int item,string *lptext,int cch),int;// check it
	declare GetTextLen(int index),int;
	declare InitStorage(int nItems,int memsize),int;
	declare InsertString(int index,string *text),int;
	declare ItemFromPoint(int x,int y),int;
	declare ResetContent(),int;
	declare SetColumnWidth(int width),int;
	declare SetTabstops(int count,int *array),int;
}

/*
sub CListbox2
*/
//---------------------------------------
class CToolbar2 : CControl2
{
	declare CToolbar2();
	declare virtual Create(int l,int t,int w,int h,int style,int exstyle,string *title,CWindow2 *parent,int id),HWND;
	declare virtual OnDestroy(); // destroys the imagelist and calls DoDefault
	// unhandled: NM_CHAR,NM_CUSTOMDRAW,NM_KEYDOWN,NM_LDOWN,NM_RCLICK,NM_RDBLCLK,NM_RELEASEDCAPTURE,NM_TOOLTIPSCREATED
	declare virtual OnBeginDrag(NMTOOLBAR *nmtb),LRESULT;
	declare virtual OnEndDrag(NMTOOLBAR *nmtb),LRESULT;
	declare virtual OnBeginAdjust(NMHDR *nmhdr),LRESULT;
	declare virtual OnEndAdjust(NMHDR *nmhdr),LRESULT;
	declare virtual OnReset(NMHDR *nmhdr),LRESULT;
	declare virtual OnQueryInsert(NMTOOLBAR *nmtb),LRESULT;
	declare virtual OnQueryDelete(NMTOOLBAR *nmtb),LRESULT;
	declare virtual OnToolbarChange(NMHDR *nmhdr),LRESULT;
	declare virtual OnCustHelp(NMHDR *nmhdr),LRESULT;
	declare virtual OnDropdown(NMTOOLBAR *nmtb),LRESULT;
	declare virtual OnGetObject(NMOBJECTNOTIFY *nmnt),LRESULT;
	declare virtual OnHotItemChange(NMTBHOTITEM *nmti),LRESULT;
	declare virtual OnDragOut(NMTOOLBAR *nmtb),LRESULT;
	declare virtual OnDeleteButton(NMTOOLBAR *nmtb),LRESULT;
	declare virtual OnGetDispInfo(NMTBDISPINFO *nmdi),LRESULT;
	declare virtual OnGetInfoTip(NMTBGETINFOTIP *nmit),LRESULT;
	declare virtual OnGetButtonInfo(NMTOOLBAR *nmtb),LRESULT;
	declare virtual OnRestore(NMTBRESTORE *nmre),LRESULT;
	declare virtual OnSave(NMTBSAVE *nmsa),LRESULT;
	declare virtual OnInitCustomize(NMHDR *nmhdr),LRESULT;

	// creates imagelist with bitmap color depth and inserts bmp.w/bmp.h buttons
	declare LoadFromResource(void *resID,COLORREF mask,int firstID),BOOL;
	declare LoadFromFile(string *path,COLORREF mask,int firstID),BOOL;
	declare LoadFromHBitmap(HBITMAP hbm,COLORREF mask,int firstID),BOOL;
	declare LoadFromModule(HINSTANCE hmod,void *resID,COLORREF mask,int firstID),BOOL;

	declare SetAnchorHighlight(BOOL enabled),BOOL;
	declare GetAnchorHighlight(),BOOL;
	declare SetDisabledImagelist(HIMAGELIST himl),HIMAGELIST;
	declare GetDisabledImagelist(),HIMAGELIST;
	declare SetExtendedStyle(DWORD exstyle),DWORD;
	declare GetExtendedStyle(),DWORD;
	declare SetStyle(DWORD style);
	declare GetStyle(),DWORD;
	declare SetTooltips(HWND tooltip);
	declare GetTooltips(),HWND;
	declare SetUnicodeFormat(BOOL unicode),BOOL;
	declare GetUnicodeFormat(),BOOL;
	declare SetRows(word cRows,word fLarger,RECT *out);
	declare GetRows(),int;
	declare GetTextRows(),int;
	declare SetHotItem(int index),int;
	declare GetHotItem(),int;
	declare SetButtonInfo(int nID,TBBUTTONINFO *info),BOOL;
	declare GetButtonInfo(int index,TBBUTTONINFO *bi),int;
//expand
	declare SetButtonSize(int cx,int cy),BOOL;
	declare GetButtonSize(),int;
	declare SetButtonWidth(int xMin,int xMax),BOOL;
	declare SetCmdID(int index,int nID),BOOL;
	declare SetButtonState(int nID,word state),BOOL;
	declare GetButtonState(int nID),DWORD;
	declare SetHotImagelist(HIMAGELIST himl),HIMAGELIST;
	declare GetHotImagelist(),HIMAGELIST;
	declare SetImagelist(int type,HIMAGELIST himl),HIMAGELIST;
	declare GetImagelist(),HIMAGELIST;
	declare SetInsertmark(int index,DWORD dwFlags); /*0,TBIMHT_AFTER,TBIMHT_BACKGROUND*/
	declare SetInsertmarkEx(TBINSERTMARK *im); /*0,TBIMHT_AFTER,TBIMHT_BACKGROUND*/
	declare GetInsertMark(TBINSERTMARK *im),BOOL;
	declare SetInsertmarkColor(COLORREF color),COLORREF;
	declare GetInsertMarkColor(),COLORREF;
	declare SetPadding(word horiz,word vert,opt word *ppOldVert=0),word;
	declare GetPadding(opt word *ppVert=0),word;
	declare SetMetrics(TBMETRICS *mt);
	declare GetMetrics(TBMETRICS *pm);

	declare CheckButton(int nID,BOOL checked),BOOL;
	declare IsButtonChecked(int nID),BOOL;
	declare PressButton(int nID,BOOL pressed),BOOL;
	declare IsButtonPressed(int nID),BOOL;
	declare EnableButton(int nID,BOOL enabled),BOOL;
	declare IsButtonEnabled(int nID),BOOL;
	declare Indeterminate(int nID,BOOL indeterminated),BOOL;
	declare IsButtonIndeterminate(int nID),BOOL;
	declare HideButton(int nID,BOOL hide),BOOL;
	declare IsButtonHidden(int nID),BOOL;
	declare IsButtonHighlighted(int nID),BOOL;

	declare AddBitmap(int nBitmaps,HINSTANCE hinst,UINT_PTR nID),int;
	declare AddBitmapEx(int nBitmaps,TBADDBITMAP *lp),int;
	declare AddButtons(int count,TBBUTTON *array),BOOL;
	declare AddString(void *ResStr,opt HINSTANCE hinst=0),int;
	declare AutoSize();
	declare GetButtonCount(),int;
	declare SetButtonStructSize(int sizeoff);
	declare ChangeBitmap(int nID,int nImage),BOOL;
	declare CommandToIndex(int nID),int;
	declare Customize();
	declare DeleteButton(int index),BOOL;
	declare GetBitmap(int nID),int;
	declare GetBitmapFlags(),DWORD;
	declare GetButton(int index,TBBUTTON *bt),BOOL;
	declare GetButtonText(int nID,string *txt),int; // to change
	declare GetItemRect(int index,RECT *rc),BOOL;
	declare GetMaxSize(SIZE *ps),BOOL;
	declare GetObject(GUID *riid,IDropTarget *ppv),HRESULT;
	declare GetRect(int nID,RECT *rc),BOOL;
	declare GetString(int index,string *buff,int cch),int;
	declare HitTest(int x,int y),int;
	declare HitTestEx(POINT *pt),int;
	declare InsertButton(int index,int bitmap,int nID,int state,int style,void *data,void *iString),BOOL;
	declare InsertButtonEx(int index,TBBUTTON *bt),BOOL;
	declare InsertmarkHitTest(POINT *pt,TBINSERTMARK *im),BOOL;
	declare LoadImages(int commctrl_type),int; /*0,1,4,5,8,9*/
	declare MapAccelerator(int nChar,UINT *ppID),BOOL;
	declare MarkButton(int nID,BOOL marked),BOOL;
	declare MoveButton(int indexFrom,int indexTo),BOOL;
	declare ReplaceBitmap(TBREPLACEBITMAP *rp),BOOL;
	declare SaveRestore(BOOL save,HKEY hkr,string *subkey,string *value);
	declare SaveRestoreEx(BOOL save,HKEY hkr,TBSAVEPARAMS *sr);
	declare SetBitmapSize(int cx,int cy),BOOL;
	declare SetColorScheme(COLORREF clrBtnHighlight,COLORREF clrBtnShadow);
	declare SetDrawTextFlags(DWORD mask,DWORD flags),DWORD;
	declare SetIndent(int indent),BOOL;
	declare SetMaxTextRows(int rows),BOOL;
	declare SetParent(HWND hwndNew),HWND;
	declare SetWindowTheme(string *theme);
}
struct TBADDBITMAP {HINSTANCE hInst;UINT_PTR nID;}
struct TBBUTTON,1 {int iBitmap;int idCommand;BYTE fsState;BYTE fsStyle;BYTE bReserved[2];DWORD_PTR dwData;INT_PTR iString;}
struct NMTOOLBAR {NMHDR hdr;int iItem;TBBUTTON tbButton;int cchText;string *pszText;RECT rcButton;}
struct TBINSERTMARK {int iButton;DWORD dwFlags;}

struct NMOBJECTNOTIFY {NMHDR hdr;int iItem;IID *piid;IUnknown *pObject;HRESULT hResult;}


